api/urls.py
from django.urls import path, include
from .views import ProductoList, ProductoDetalle

urlpatterns = [
    path('v1/productos/',ProductoList.as_view(),name='producto_list'),
    path('v1/productos/<str:codigo>',ProductoDetalle.as_view(),name='producto_detalle'),
]

app/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [

    path('',include(('bases.urls','bases'), namespace='bases')),
    path('inv/',include(('inv.urls','inv'), namespace='inv')),
    path('cmp/', include(('cmp.urls', 'cmp'), namespace='cmp')),
    path('fac/', include(('fac.urls', 'fac'), namespace='fac')),
    path('api/', include(('api.urls', 'api'), namespace='api')),
    
    path('admin/', admin.site.urls),
]

fac/urls.py
from django.urls import path, include

from .views import ClienteView,ClienteNew,ClienteEdit,clienteInactivar, \
    FacturaView, facturas, \
    ProductoView, \
    borrar_detalle_factura

from .reportes import imprimir_factura_recibo, imprimir_factura_list

urlpatterns = [
    path('clientes/',ClienteView.as_view(), name="cliente_list"),
    path('clientes/new',ClienteNew.as_view(), name="cliente_new"),
    path('clientes/<int:pk>',ClienteEdit.as_view(), name="cliente_edit"),
    path('clientes/estado/<int:id>',clienteInactivar, name="cliente_inactivar"),

    path('facturas/',FacturaView.as_view(), name="factura_list"),
    path('facturas/new',facturas, name="factura_new"),
    path('facturas/edit/<int:id>',facturas, name="factura_edit"),
    
    path('facturas/buscar-producto',ProductoView.as_view(), name="factura_producto"),

    path('facturas/borrar-detalle/<int:id>',borrar_detalle_factura, name="factura_borrar_detalle"),

    path('facturas/imprimir/<int:id>',imprimir_factura_recibo, name="factura_imprimir_one"),

    path('facturas/imprimir-todas/<str:f1>/<str:f2>',imprimir_factura_list, name="factura_imprimir_all"),



]

fac/models.py
from django.db import models

#Para los signals
from django.db.models.signals import post_save, post_delete
from django.dispatch import receiver
from django.db.models import Sum

from bases.models import ClaseModelo, ClaseModelo2
from inv.models import Producto

class Cliente(ClaseModelo):
    NAT='Natural'
    JUR='Jurídica'
    TIPO_CLIENTE = [
        (NAT,'Natural'),
        (JUR,'Jurídica')
    ]
    nombres = models.CharField(
        max_length=100
    )
    apellidos = models.CharField(
        max_length=100
    )
    celular = models.CharField(
        max_length=20,
        null=True,
        blank=True
    )
    tipo=models.CharField(
        max_length=10,
        choices=TIPO_CLIENTE,
        default=NAT
    )

    def __str__(self):
        return '{} {}'.format(self.apellidos,self.nombres)

    def save(self):
        self.nombres = self.nombres.upper()
        self.apellidos = self.apellidos.upper()
        super(Cliente, self).save()

    class Meta:
        verbose_name_plural = "Clientes"

    
class FacturaEnc(ClaseModelo2):
    cliente = models.ForeignKey(Cliente, on_delete=models.CASCADE)
    fecha = models.DateTimeField(auto_now_add=True)
    sub_total=models.FloatField(default=0)
    descuento=models.FloatField(default=0)
    total=models.FloatField(default=0)

    def __str__(self):
        return '{}'.format(self.id)

    def save(self):
        self.total = self.sub_total - self.descuento
        super(FacturaEnc,self).save()

    class Meta:
        verbose_name_plural = "Encabezado Facturas"
        verbose_name="Encabezado Factura"
        permissions = [
            ('sup_caja_facturaenc','Permisos de Supervisor de Caja Encabezado')
        ]
    

class FacturaDet(ClaseModelo2):
    factura = models.ForeignKey(FacturaEnc,on_delete=models.CASCADE)
    producto=models.ForeignKey(Producto,on_delete=models.CASCADE)
    cantidad=models.BigIntegerField(default=0)
    precio=models.FloatField(default=0)
    sub_total=models.FloatField(default=0)
    descuento=models.FloatField(default=0)
    total=models.FloatField(default=0)

    def __str__(self):
        return '{}'.format(self.producto)

    def save(self):
        self.sub_total = float(float(int(self.cantidad)) * float(self.precio))
        self.total = self.sub_total - float(self.descuento)
        super(FacturaDet, self).save()
    
    class Meta:
        verbose_name_plural = "Detalles Facturas"
        verbose_name="Detalle Factura"
        permissions = [
            ('sup_caja_facturadet','Permisos de Supervisor de Caja Detalle')
        ]


@receiver(post_save, sender=FacturaDet)
def detalle_fac_guardar(sender,instance,**kwargs):
    factura_id = instance.factura.id
    producto_id = instance.producto.id

    enc = FacturaEnc.objects.get(pk=factura_id)
    if enc:
        sub_total = FacturaDet.objects \
            .filter(factura=factura_id) \
            .aggregate(sub_total=Sum('sub_total')) \
            .get('sub_total',0.00)
        
        descuento = FacturaDet.objects \
            .filter(factura=factura_id) \
            .aggregate(descuento=Sum('descuento')) \
            .get('descuento',0.00)
        
        enc.sub_total = sub_total
        enc.descuento = descuento
        enc.save()

    prod=Producto.objects.filter(pk=producto_id).first()
    if prod:
        cantidad = int(prod.existencia) - int(instance.cantidad)
        prod.existencia = cantidad
        prod.save()

fac/forms.py
from django import forms

from .models import Cliente

class ClienteForm(forms.ModelForm):
    class Meta:
        model=Cliente
        fields=['nombres','apellidos','tipo',
            'celular','estado']
        exclude = ['um','fm','uc','fc']

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            })

fac/views.py
from django.shortcuts import render,redirect
from django.views import generic

from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse_lazy
from django.contrib.auth.decorators import login_required, permission_required
from django.http import HttpResponse
from datetime import datetime
from django.contrib import messages

from django.contrib.auth import authenticate

from bases.views import SinPrivilegios

from .models import Cliente, FacturaEnc, FacturaDet
from .forms import ClienteForm
import inv.views as inv
from inv.models import Producto

class ClienteView(SinPrivilegios, generic.ListView):
    model = Cliente
    template_name = "fac/cliente_list.html"
    context_object_name = "obj"
    permission_required="cmp.view_cliente"


class VistaBaseCreate(SuccessMessageMixin,SinPrivilegios, \
    generic.CreateView):
    context_object_name = 'obj'
    success_message="Registro Agregado Satisfactoriamente"

    def form_valid(self, form):
        form.instance.uc = self.request.user
        return super().form_valid(form)

class VistaBaseEdit(SuccessMessageMixin,SinPrivilegios, \
    generic.UpdateView):
    context_object_name = 'obj'
    success_message="Registro Actualizado Satisfactoriamente"

    def form_valid(self, form):
        form.instance.um = self.request.user.id
        return super().form_valid(form)


class ClienteNew(VistaBaseCreate):
    model=Cliente
    template_name="fac/cliente_form.html"
    form_class=ClienteForm
    success_url= reverse_lazy("fac:cliente_list")
    permission_required="fac.add_cliente"


class ClienteEdit(VistaBaseEdit):
    model=Cliente
    template_name="fac/cliente_form.html"
    form_class=ClienteForm
    success_url= reverse_lazy("fac:cliente_list")
    permission_required="fac.change_cliente"


@login_required(login_url="/login/")
@permission_required("fac.change_cliente",login_url="/login/")
def clienteInactivar(request,id):
    cliente = Cliente.objects.filter(pk=id).first()

    if request.method=="POST":
        if cliente:
            cliente.estado = not cliente.estado
            cliente.save()
            return HttpResponse("OK")
        return HttpResponse("FAIL")
    
    return HttpResponse("FAIL")

class FacturaView(SinPrivilegios, generic.ListView):
    model = FacturaEnc
    template_name = "fac/factura_list.html"
    context_object_name = "obj"
    permission_required="fac.view_facturaenc"


@login_required(login_url='/login/')
@permission_required('fac.change_facturaenc', login_url='bases:sin_privilegios')
def facturas(request,id=None):
    template_name='fac/facturas.html'

    detalle = {}
    clientes = Cliente.objects.filter(estado=True)
    
    if request.method == "GET":
        enc = FacturaEnc.objects.filter(pk=id).first()
        if not enc:
            encabezado = {
                'id':0,
                'fecha':datetime.today(),
                'cliente':0,
                'sub_total':0.00,
                'descuento':0.00,
                'total': 0.00
            }
            detalle=None
        else:
            encabezado = {
                'id':enc.id,
                'fecha':enc.fecha,
                'cliente':enc.cliente,
                'sub_total':enc.sub_total,
                'descuento':enc.descuento,
                'total':enc.total
            }

        detalle=FacturaDet.objects.filter(factura=enc)
        contexto = {"enc":encabezado,"det":detalle,"clientes":clientes}
        return render(request,template_name,contexto)
    
    if request.method == "POST":
        cliente = request.POST.get("enc_cliente")
        fecha  = request.POST.get("fecha")
        cli=Cliente.objects.get(pk=cliente)

        if not id:
            enc = FacturaEnc(
                cliente = cli,
                fecha = fecha
            )
            if enc:
                enc.save()
                id = enc.id
        else:
            enc = FacturaEnc.objects.filter(pk=id).first()
            if enc:
                enc.cliente = cli
                enc.save()

        if not id:
            messages.error(request,'No Puedo Continuar No Pude Detectar No. de Factura')
            return redirect("fac:factura_list")
        
        codigo = request.POST.get("codigo")
        cantidad = request.POST.get("cantidad")
        precio = request.POST.get("precio")
        s_total = request.POST.get("sub_total_detalle")
        descuento = request.POST.get("descuento_detalle")
        total = request.POST.get("total_detalle")

        prod = Producto.objects.get(codigo=codigo)
        det = FacturaDet(
            factura = enc,
            producto = prod,
            cantidad = cantidad,
            precio = precio,
            sub_total = s_total,
            descuento = descuento,
            total = total
        )
        
        if det:
            det.save()
        
        return redirect("fac:factura_edit",id=id)

    return render(request,template_name,contexto)


class ProductoView(inv.ProductoView):
    template_name="fac/buscar_producto.html" 


def borrar_detalle_factura(request, id):
    template_name = "fac/factura_borrar_detalle.html"

    det = FacturaDet.objects.get(pk=id)

    if request.method=="GET":
        context={"det":det}

    if request.method == "POST":
        usr = request.POST.get("usuario")
        pas = request.POST.get("pass")

        user =authenticate(username=usr,password=pas)

        if not user:
            return HttpResponse("Usuario o Clave Incorrecta")
        
        if not user.is_active:
            return HttpResponse("Usuario Inactivo")

        if user.is_superuser or user.has_perm("fac.sup_caja_facturadet"):
            det.id = None
            det.cantidad = (-1 * det.cantidad)
            det.sub_total = (-1 * det.sub_total)
            det.descuento = (-1 * det.descuento)
            det.total = (-1 * det.total)
            det.save()

            return HttpResponse("ok")

        return HttpResponse("Usuario no autorizado")
    
    return render(request,template_name,context)

fac/templates/fac/buscar_producto.html
<div class="modal-dialog modal-lg">
    <div class="modal-content">
        <div class="col-xl-12 col-md-12 mb-12">
            <div class="card border-left-warning shadow h-100 py-2">
                <div class="card-body">
                    <div class="row no-gutters align-items-center">
                    <div class="col mr-2">
                        <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                            Buscar Producto
                        </div>
                        <div class="dropdown-divider"></div>
                        
                        <div class="row">
                                <table
                                id="tblProducto"
                                data-pagination="true"
                                data-search="true"
                                data-show-columns="true"
                                data-show-fullscreen="true"
                                data-locale="es-NI"
                                >
                                <thead>
                                  <th data-sortable="true" data-field="id">Id</th>        
                                  <th data-sortable="true" data-field="codigo">Código</th>
                                  <th data-sortable="true" data-field="codigo_barra">Barra</th>
                                  <th data-field="descripcion">Descripción</th>
                                  <th data-field="existencia">Existencia</th>
                                  <th data-field="precio">Precio</th>
                                  <th class="all">Acciones</th>
                                </thead>
                                <tbody>
                                  {% for item in obj%}
                                  <tr>
                                    <td>{{ item.id }}</td>
                                    <td>{{ item.codigo }}</td>
                                    <td>{{ item.codigo_barra }}</td>
                                    <td>{{item.descripcion}}</td>
                                    <td>{{item.existencia}}</td>
                                    <td>{{item.precio}}</td>
                                    <td>
                                        {% if item.existencia > 0 and item.estado %}
                                        <button class="btn btn-warning btn-circle" id="btnSelect" 
                                        onclick="seleccionarProducto({{item.id}},'{{item.codigo}}','{{item.descripcion}}',{{item.precio}})">
                                            <i class="far fa-hand-pointer"></i>
                                        </button>
                                        {% endif %}
                                    </td>
                                  </tr>
                                  {% endfor %}
                                </tbody>
                              </table>
                        </div>
                        <div class="dropdown-divider"></div>
                        <div class="row">
                            <div class="col">
                                <!-- <button type="submit" class="btn btn-danger"><span class="fa fa-save"></span> Guardar</button> -->
                                <button type="button" id="btnCancelar" class="btn btn-success">
                                        <!-- onclick="return cerrar_modal()" -->
                                        Cancelar
                                </button>
                            </div>
                        </div>
                    </div>
                    <div class="col-auto">
                        <i class="far fa-calendar-plus fa-2x text-gray-300"></i>
                    </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div> 
{% block js_page %}
<script>
    $(function () {

        $("#btnCancelar").click(function(e){
            e.preventDefault();
            cerrar_modal();

        });
    });
    $('#tblProducto').bootstrapTable();

    function seleccionarProducto(id,codigo,descripcion,precio){
        $("#codigo").val(codigo);
        $("#descripcion").val(descripcion);
        $("#precio").val(precio);
        $("#btnCancelar").click();
        $("#codigo").select();
        $("#codigo").focus();

    }

</script>
{% endblock %}

fac/templates/fac/cliente_form.html
<div class="modal-dialog modal-lg">
    <div class="modal-content">
        {% if obj %}
        <form role="form" action="{% url 'fac:cliente_edit' obj.pk %}" method="post"  class="form-inline">
        {% else %}
        <form role="form" action="{% url 'fac:cliente_new' %}" method="post"  class="form-inline">
        {% endif %}
            <div class="col-xl-12 col-md-12 mb-12">
                {% if obj %}
                <div class="card border-left-warning shadow h-100 py-2">
                {% else %}
                <div class="card border-left-success shadow h-100 py-2">
                {% endif %}
                <div class="card-body">
                    <div class="row no-gutters align-items-center">
                    <div class="col mr-2">
                        <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                            {% if obj %} Editar {% else %} Nuevo {% endif %} Cliente
                        </div>
                        <div class="dropdown-divider"></div>
                        {% csrf_token %}
                        <div class="row">
                            {{ form.as_p }}
                        </div>
                        <div class="dropdown-divider"></div>
                        <div class="row">
                            <div class="col">
                                <button type="submit" class="btn btn-danger"><span class="fa fa-save"></span> Guardar</button>
                                <button type="button" class="btn btn-success" onclick="return cerrar_modal()">
                                        Cancelar
                                </button>
                            </div>
                        </div>
                    </div>
                    <div class="col-auto">
                        <i class="far fa-calendar-plus fa-2x text-gray-300"></i>
                    </div>
                    </div>
                </div>
                </div>
            </div>
        </form>
    </div>
</div> 

fac/templates/fac/cliente_list.html
{% extends 'base/base.html' %}

{% block page_content %}
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Listado de Clientes</h6>
    <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Acciones:</div>
        <a class="dropdown-item" onclick="return abrir_modal('{% url 'fac:cliente_new' %}')" href="#"><i class="far fa-calendar-plus"></i> Nuevo</a>
      </div>
    </div>
  </div>
  <!-- Card Body -->
  <div class="card-body">
    {% if not obj %}
    <div class="alert alert-info">No Hay Clientes</div>
    {% endif %}
    <div class="buttons-toolbar">
        <a class="dropdown-item" onclick="return abrir_modal('{% url 'fac:cliente_new' %}')" href="#"><i class="far fa-calendar-plus"></i> Nuevo</a>
    </div>

    <table 
      id="table"
      data-toggle="table"
      data-pagination="true"
      data-search="true"
      data-show-columns="true"
      data-show-toggle="true"
      data-show-fullscreen="true"
      data-toolbar=".buttons-toolbar"
      data-locale="es-NI"
    >
      <thead>
          <th data-sortable="true" data-field="id">Id</th>        
          <th data-sortable="true" data-field="nombres">Nombres</th>
          <th data-sortable="true" data-field="apellidos">Apellidos</th>
          <th data-sortable="true" data-field="tipo">Tipo</th>
          <th data-field="telefono">Teléfono</th>
          <th data-field="estado">Estado</th>
          <th class="all">Acciones</th>  
      </thead>
      <tbody>
        {% for item in obj%}
        <tr>
          <td>{{ item.id }}</td>
          <td>{{ item.nombres }}</td>
          <td>{{ item.apellidos }}</td>
          <td>{{item.tipo}}</td>
          <td>{{ item.celular }}</td>
          <td >{#item.estado|yesno:"Activo,Inactivo"#}
            <div onclick="inactivar({{item.id}})">
                {% if item.estado %}
                <i class="far fa-thumbs-up text-primary"></i>
              {% else %}
                <i class="far fa-thumbs-down text-danger"></i>
              {% endif %}
            </div>
          </td>
          <td>
            <button class="btn btn-warning btn-circle" onclick="return abrir_modal('{% url 'fac:cliente_edit' item.id %}')"><i class="far fa-edit"></i></button>
          </td>
        </tr>
        {% endfor %}
      </tbody>

    </table>
  </div>
</div>
{% endblock %}
{% block js_page %}
<script>
  function inactivar(id)
  {
    var data = {id:id};
    data = JSON.stringify(data);
    var token = '{{csrf_token}}';
    // alert(token);
    // alert(id);
    
    $.ajax({
      headers : {"X-CSRFToken": token},
      type:"POST",
      url:"/fac/clientes/estado/"+id,
      data: data,
      success: function(response){
        if(response==="OK")
        {
          location.reload(true);
        }
        else{
          mensaje("Error Intentado Cambiar Estado a Cliente");
        }
      },
      error: function(jqXHR, textStatus, errorThrow){
        console.log(textStatus, errorThrow);
        mensaje(errorThrow,'red');
        cerrar_modal();
      }
    });
  }
// Call the dataTables jQuery plugin
// $(document).ready(function() {
//   $('.table').DataTable();
// });
</script>
{% endblock %}

fac/templates/fac/factura_borrar_detalle.html
<label class="text-danger">¿Anular Producto <b>{{det.producto.descripcion}}</b> de factura <b>{{det.factura.id}}</b>?</label>
<div>
    <div class="form-group">
        <label class="control-label">Usuario</label>
        <input type="text" id="usuario" class="form-control" required>
    </div>
    <div class="form-group">
        <label class="control-label">Contraseña</label>
        <input type="password" id="password" class="form-control" required>
    </div>
</div>

fac/templates/fac/factura_list.html
{% extends 'base/base.html' %}

{% block page_content %}
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Listado de Facturas</h6>
    <!-- <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Acciones:</div>
        <a class="dropdown-item" onclick="return abrir_modal('{% url 'fac:cliente_new' %}')" href="#"><i class="far fa-calendar-plus"></i> Nuevo</a>
      </div>
    </div> -->
  </div>
  <!-- Card Body -->
  <div class="card-body">
    <div class="row">
      <div class="col-md-4">
        <input type="text" class="form-class" name="f1" id="f1" readonly>
      </div>
      <div class="col-md-4">
        <input type="text" class="form-class" name="f2" id="f2" readonly>
      </div>
      <div class="col-md-4">
        <button class="btn btn-warning" type="button" id="btnPrint">Imprimir</button>
      </div>
    </div>
    <hr>

    
    {% if not obj %}
    <div class="alert alert-info">No Hay Facturas</div>
    {% endif %}
    <div class="buttons-toolbar">
        <a class="btn btn-success" href="{% url 'fac:factura_new' %}"><i cass="far fa-calendar-plus"></i> Nuevo</a>
    </div>

    <table 
      id="table"
      data-toggle="table"
      data-pagination="true"
      data-search="true"
      data-show-columns="true"
      data-show-toggle="true"
      data-show-fullscreen="true"
      data-toolbar=".buttons-toolbar"
      data-locale="es-NI"
    >
    <thead>
      <th data-sortable="true" data-field="id">No.</th>        
      <th data-sortable="true" data-field="nombres">Cliente</th>
      <th data-sortable="true" data-field="apellidos">Total</th>
      <th data-field="estado">Estado</th>
      <th class="all">Acciones</th>
    </thead>
    <tbody>
      {% for item in obj%}
      <tr>
        <td>{{ item.id }}</td>
        <td>{{ item.cliente }}</td>
        <td>{{ item.total }}</td>
        <td>{{item.estado|yesno:"Activo,Inactivo"}}</td>
        <td>
          <a href="{% url 'fac:factura_edit' item.id %}" class="href btn btn-warning btn-circle">
              <i class="far fa-edit"></i>
          </a>
        </td>
      </tr>
      {% endfor %}
    </tbody>


    </table>
  </div>
</div>
{% endblock %}
{% block js_page %}
<script>
$(function(){
  $("#f1, #f2").datetimepicker({
      format: 'Y-m-d',
      timepicker:false
  });

  $("#btnPrint").click(function(e){
    e.preventDefault();
    var f1,f2;
    f1 = $("#f1").val();
    f2 = $("#f2").val();
    if(f1=="" || f1==null){
      f1="2019-06-01";
    }
    if(f2=="" || f2==null){
      var d = new Date();
      var f2 = d.getFullYear() + "-" + (d.getMonth()+1) + "-" + d.getDate();
    }
    
    var url = "imprimir-todas/" + f1 + "/" + f2;

    window.open(url,'facturas');
    
  });
});
</script>
{% endblock %}

fac/templates/fac/factura_one.html
{% load static %}
<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Listado de Compras</title>
    <link rel="stylesheet" href="{% static 'base/css/recibo.css' %}">
    <style type="text/css">
        @page {
             width: 58mm; 
            size: auto;   
            margin: 0mm;
            }
    </style>
</head>
<body onload="window.print();window.close()" class="receipt">
    <div class="col-md-1 col-sm-1 col-xs-1 col-xl-1">
        <center>
            <b class="text-center">Tienda UDEMY DEBSCONSULTORES</b><br> 
            <small>Direccion</small><br>
            <small>FACTURA No. {{enc.factura}}</small><br>
        </center>
        <small>
            <br>
            <b>Factura No.:</b>&nbsp;&nbsp;{{enc.id}}&nbsp;&nbsp;
            <b>Fecha Fact:</b>&nbsp;&nbsp;{{enc.fecha}}&nbsp;&nbsp; <br>
            <b>Cliente:</b>&nbsp;&nbsp;{{enc.cliente.id}}&nbsp;&nbsp;- {{enc.cliente}}<br>
            <br><br>
        </small>
        <table class="table table-condensed table-sm" width="60%">
            <thead>
                <th>Código</th>
                <th  align='right'>Cant.</th>
                <th  align='right'>P. Unit.</th>
                <th  align='right'>Sub Total</th>
                <th  align='right'>Descuento</th>
                <th  align='right'>Total</th>
            </thead>
            <tbody>
                {% for obj in detalle %}
                <tr>
                    <td>{{obj.producto.id}}</td>
                    <td>{{obj.cantidad}}</td>
                    <td>{{obj.precio}}</td>
                    <td>{{obj.sub_total}}</td>
                    <td>{{obj.descuento}}</td>
                    <td>{{obj.total}}</td>
                </tr>
                <tr>
                    <td colspan="5">{{obj.producto}}</td>
                </tr>
                {% endfor %}
            </tbody>
        </table>
        <div class="col-xs-1"></div>
        <div class="col-xs-11">
            <div class="pull-right">
            <table class="table-responsive dt-responsive nowrap">
                <thead>
                    <th colspan=2>Totales</th>
                </thead>
                <tbody>
                    <tr>
                        <td>Sub Total:</td> <td align='right'>{{enc.sub_total}}</td>
                    </tr>
                    <tr>
                        <td>Iva:</td> <td align='right'>{{enc.descuento}}</td>
                    </tr>
                    <tr>
                        <td>Total:</td> <td align='right'><b>{{enc.total}}</b></td>
                    </tr>
                </tbody>
            </table>
            </div>
        </div>
        <div class="row">
        <small class="pie">
            <br><br>
            <center>
                Creada por:  {{enc.uc}} - Fecha:  {{enc.fc}}
                <br>
                <i>&copy; &reg; <b>Daniel Bojorge y/o DEBS Consultores</b><br> - debsconsultores@gmail.com</i> 
            </center>
        </small>
        </div>
    </div>
</body>
</html>